------------------------------------------------------------------
-- These are the SQL statements to create the objects from 
-- the Oracle Model in an Oracle database.
------------------------------------------------------------------
 
REM
REM Start Tables
REM
 
REM 
REM Message : Created Table :ADIA.ADRESSE
REM
CREATE TABLE ADIA.ADRESSE(ADID NUMBER (11,0) NOT NULL,HID NUMBER (11,0)
 NOT NULL,NAME VARCHAR2 (50)  ,NAME2 VARCHAR2 (50)  ,STRASSE VARCHAR2 (50)
  ,NUMMER NUMBER (11,0)  ,PLZ NUMBER (11,0)  ,STADT VARCHAR2 (50)  ,BUNDESLAND
 VARCHAR2 (50)  ,LAND VARCHAR2 (50)  ,TELEFON VARCHAR2 (50)  ,FAX VARCHAR2
 (30)  ,E_MAIL VARCHAR2 (100)  ,INTERNETADRESSE VARCHAR2 (100)  ) TABLESPACE DIPLOM
;

ALTER TABLE ADIA.ADRESSE  MODIFY (ADID DEFAULT 0);
ALTER TABLE ADIA.ADRESSE  MODIFY (HID DEFAULT 0);
ALTER TABLE ADIA.ADRESSE  MODIFY (NUMMER DEFAULT 0);
ALTER TABLE ADIA.ADRESSE  MODIFY (PLZ DEFAULT 0);
REM 
REM Message : Processed defaults for table :ADIA.ADRESSE
REM


REM 
REM Message : Created Table :ADIA.BILDER
REM 
CREATE TABLE ADIA.BILDER(BILDID NUMBER (11,0) NOT NULL,PID NUMBER (11,0)
  ,BILDTYP VARCHAR2 (30)  ,QUELLE VARCHAR2 (250)  ,BESCHREIBUNG VARCHAR2
 (250)  ) TABLESPACE DIPLOM
;

ALTER TABLE ADIA.BILDER  MODIFY (BILDID DEFAULT 0);
ALTER TABLE ADIA.BILDER  MODIFY (PID DEFAULT 0);
REM 
REM Message : Processed defaults for table :ADIA.BILDER
REM 


REM 
REM Message : Created Table :ADIA.GRUPPEN_TYP
REM 
CREATE TABLE ADIA.GRUPPEN_TYP(TYPNR NUMBER (11,0)  ,BEZEICHNUNG VARCHAR2
 (50)  ,BESCHREIBUNG VARCHAR2 (50)  ) TABLESPACE DIPLOM
;

ALTER TABLE ADIA.GRUPPEN_TYP  MODIFY (TYPNR DEFAULT 0);
ALTER TABLE ADIA.GRUPPEN_TYP  MODIFY (BEZEICHNUNG DEFAULT TO_CHAR(0));
REM 
REM Message : Processed defaults for table :ADIA.GRUPPEN_TYP
REM


REM 
REM Message : Created Table :ADIA.HERSTELLER
REM 
CREATE TABLE ADIA.HERSTELLER(HID NUMBER (11,0) NOT NULL,NAME VARCHAR2 (50)
  ) TABLESPACE DIPLOM
;

ALTER TABLE ADIA.HERSTELLER  MODIFY (HID DEFAULT 0);
REM 
REM Message : Processed defaults for table :ADIA.HERSTELLER
REM 


REM 
REM Message : Created Table :ADIA.JOIN_G_P
REM 
CREATE TABLE ADIA.JOIN_G_P(GID NUMBER (11,0) NOT NULL,PID NUMBER (11,0)
  ,PREIS NUMBER (15,4)  ) TABLESPACE DIPLOM
;

ALTER TABLE ADIA.JOIN_G_P  MODIFY (GID DEFAULT 0);
ALTER TABLE ADIA.JOIN_G_P  MODIFY (PID DEFAULT 0);
ALTER TABLE ADIA.JOIN_G_P  MODIFY (PREIS DEFAULT 0);
REM 
REM Message : Processed defaults for table :ADIA.JOIN_G_P
REM 


REM 
REM Message : Created Table :ADIA.KATALOG
REM 
CREATE TABLE ADIA.KATALOG(CID NUMBER (11,0) NOT NULL,KATALOG_ID NUMBER
 (11,0) NOT NULL,NAME VARCHAR2 (100)  ,ANBIETER VARCHAR2 (50)  ,VERSION
 VARCHAR2 (7)  ,ERSTELLUNGSDATUM DATE  ,IMPLEMENTIERUNGSDATUM DATE NOT
 NULL,AKTIV NUMBER (1,0) NOT NULL,STRUKTUR NUMBER (1,0)  ,DATEI VARCHAR2
 (50)  ) TABLESPACE DIPLOM
;

ALTER TABLE ADIA.KATALOG  MODIFY (CID DEFAULT 0);
ALTER TABLE ADIA.KATALOG  MODIFY (KATALOG_ID DEFAULT 0);
ALTER TABLE ADIA.KATALOG  MODIFY (AKTIV DEFAULT 0);
ALTER TABLE ADIA.KATALOG  MODIFY (STRUKTUR DEFAULT 0);
REM 
REM Message : Processed defaults for table :ADIA.KATALOG
REM 


REM 
REM Message : Created Table :ADIA.PRODUKT
REM 
CREATE TABLE ADIA.PRODUKT(PID NUMBER (11,0) NOT NULL,BEZEICHNUNG VARCHAR2
 (40)  ,BESCHREIBUNG CLOB  ,EINHEIT VARCHAR2 (3)  ,PREIS_EINHEIT NUMBER
 (11,0)  ,WAEHRUNG VARCHAR2 (5)  ,HID NUMBER (11,0)  ,HPNR NUMBER (11,0)
  ) TABLESPACE DIPLOM
;

ALTER TABLE ADIA.PRODUKT  MODIFY (PID DEFAULT 0);
ALTER TABLE ADIA.PRODUKT  MODIFY (PREIS_EINHEIT DEFAULT 0);
ALTER TABLE ADIA.PRODUKT  MODIFY (HID DEFAULT 0);
ALTER TABLE ADIA.PRODUKT  MODIFY (HPNR DEFAULT 0);
REM 
REM Message : Processed defaults for table :ADIA.PRODUKT
REM 


REM 
REM Message : Created Table :ADIA.STRUKTUR
REM 
CREATE TABLE ADIA.STRUKTUR(CID NUMBER (11,0) NOT NULL,GID NUMBER (11,0)
  ,MUTTERGRUPPE_ID NUMBER (11,0) NOT NULL,TYPNR NUMBER (11,0) NOT NULL,NAME
 VARCHAR2 (50)  ,BESCHREIBUNG VARCHAR2 (250)  ) TABLESPACE DIPLOM
;

ALTER TABLE ADIA.STRUKTUR  MODIFY (CID DEFAULT 0);
ALTER TABLE ADIA.STRUKTUR  MODIFY (GID DEFAULT 0);
ALTER TABLE ADIA.STRUKTUR  MODIFY (MUTTERGRUPPE_ID DEFAULT 0);
ALTER TABLE ADIA.STRUKTUR  MODIFY (TYPNR DEFAULT 0);
REM 
REM Message : Processed defaults for table :ADIA.STRUKTUR
REM 


REM
REM End Tables
REM
 
REM
REM Start Indexes
REM
 
REM 
REM Message : Created Index :UQ_ADRESSE
REM 
CREATE UNIQUE     INDEX ADIA.UQ_ADRESSE ON ADIA.ADRESSE ( FAX ) TABLESPACE INDX
;

REM 
REM Message : Created Index :UQ_ADRESSE_1
REM 
CREATE UNIQUE     INDEX ADIA.UQ_ADRESSE_1 ON ADIA.ADRESSE ( TELEFON ) TABLESPACE INDX
;

REM 
REM Message : Created Index :AID
REM 
CREATE  INDEX ADIA.AID ON ADIA.BILDER ( PID ) TABLESPACE INDX
;

REM 
REM Message : Created Index :BILDID
REM 
CREATE  INDEX ADIA.BILDID ON ADIA.BILDER ( BILDID ) TABLESPACE INDX
;

REM 
REM Message : Created Index :HID
REM 
CREATE  INDEX ADIA.HID ON ADIA.HERSTELLER ( HID ) TABLESPACE INDX
;

REM 
REM Message : Created Index :AID_1
REM 
CREATE  INDEX ADIA.AID_1 ON ADIA.JOIN_G_P ( PID ) TABLESPACE INDX
;

REM 
REM Message : Created Index :GID
REM 
CREATE  INDEX ADIA.GID ON ADIA.JOIN_G_P ( GID ) TABLESPACE INDX
;

REM 
REM Message : Created Index :EXT_PRODUCT_ID
REM 
CREATE  INDEX ADIA.EXT_PRODUCT_ID ON ADIA.PRODUKT ( PID ) TABLESPACE INDX
;

REM 
REM Message : Created Index :MANUFACTCODE
REM 
CREATE  INDEX ADIA.MANUFACTCODE ON ADIA.PRODUKT ( HID ) TABLESPACE INDX
;

REM 
REM Message : Created Index :CATALOG_ID
REM 
CREATE  INDEX ADIA.CATALOG_ID ON ADIA.STRUKTUR ( GID ) TABLESPACE INDX
;

REM 
REM Message : Created Index :CID
REM 
CREATE  INDEX ADIA.CID ON ADIA.STRUKTUR ( CID ) TABLESPACE INDX
;

REM 
REM Message : Created Index :PARENT_ID
REM 
CREATE  INDEX ADIA.PARENT_ID ON ADIA.STRUKTUR ( MUTTERGRUPPE_ID ) TABLESPACE INDX
;

REM
REM End Indexes
REM
 
REM
REM Start Primary Keys
REM
 
REM 
REM Message : Created Primary Key :PK_ADRESSE
REM 
ALTER TABLE ADIA.ADRESSE ADD ( CONSTRAINT PK_ADRESSE PRIMARY KEY ( ADID
 ) ) 
;

REM 
REM Message : Created Primary Key :PK_BILDER
REM 
ALTER TABLE ADIA.BILDER ADD ( CONSTRAINT PK_BILDER PRIMARY KEY ( BILDID
 ) ) 
;

REM 
REM Message : Created Primary Key :PK_GRUPPEN_TYP
REM 
ALTER TABLE ADIA.GRUPPEN_TYP ADD ( CONSTRAINT PK_GRUPPEN_TYP PRIMARY KEY
 ( TYPNR ) ) 
;

REM 
REM Message : Created Primary Key :PK_HERSTELLER
REM 
ALTER TABLE ADIA.HERSTELLER ADD ( CONSTRAINT PK_HERSTELLER PRIMARY KEY
 ( HID ) ) 
;

REM 
REM Message : Created Primary Key :PK_JOIN_G_P
REM 
ALTER TABLE ADIA.JOIN_G_P ADD ( CONSTRAINT PK_JOIN_G_P PRIMARY KEY ( GID,PID
 ) ) 
;

REM 
REM Message : Created Primary Key :PK_KATALOG
REM 
ALTER TABLE ADIA.KATALOG ADD ( CONSTRAINT PK_KATALOG PRIMARY KEY ( CID
 ) ) 
;

REM 
REM Message : Created Primary Key :PK_PRODUKT
REM 
ALTER TABLE ADIA.PRODUKT ADD ( CONSTRAINT PK_PRODUKT PRIMARY KEY ( PID
 ) ) 
;

REM 
REM Message : Created Primary Key :PK_STRUKTUR
REM 
ALTER TABLE ADIA.STRUKTUR ADD ( CONSTRAINT PK_STRUKTUR PRIMARY KEY ( GID
 ) ) 
;

REM
REM End Primary Keys
REM
 
REM
REM Start Foreign Keys
REM
 
REM 
REM Message : Created Foreign Key :GRUPPEN_TYPSTRUKTUR
REM 
ALTER TABLE ADIA.STRUKTUR ADD ( CONSTRAINT  GRUPPEN_TYPSTRUKTUR FOREIGN
 KEY ( TYPNR )  REFERENCES ADIA.GRUPPEN_TYP ( TYPNR ))
;

REM 
REM Message : Created Foreign Key :HERSTELLERADRESSE
REM 
ALTER TABLE ADIA.ADRESSE ADD ( CONSTRAINT  HERSTELLERADRESSE FOREIGN KEY
 ( HID )  REFERENCES ADIA.HERSTELLER ( HID ) )
;

REM 
REM Message : Created Foreign Key :HERSTELLERPRODUKT
REM 
ALTER TABLE ADIA.PRODUKT ADD ( CONSTRAINT  HERSTELLERPRODUKT FOREIGN KEY
 ( HID )  REFERENCES ADIA.HERSTELLER ( HID ))
;

REM 
REM Message : Created Foreign Key :KATALOGSTRUKTUR
REM 
ALTER TABLE ADIA.STRUKTUR ADD ( CONSTRAINT  KATALOGSTRUKTUR FOREIGN KEY
 ( CID )  REFERENCES ADIA.KATALOG ( CID ))
;

REM 
REM Message : Created Foreign Key :PRODUKTBILDER
REM 
ALTER TABLE ADIA.BILDER ADD ( CONSTRAINT  PRODUKTBILDER FOREIGN KEY ( PID
 )  REFERENCES ADIA.PRODUKT ( PID ))
;

REM 
REM Message : Created Foreign Key :ProduktJOIN_G_P
REM 
ALTER TABLE ADIA.JOIN_G_P ADD ( CONSTRAINT  ProduktJOIN_G_P FOREIGN KEY
 ( PID )  REFERENCES ADIA.PRODUKT ( PID ))
;

REM 
REM Message : Created Foreign Key :STRUKTURJOIN_G_P
REM 
ALTER TABLE ADIA.JOIN_G_P ADD ( CONSTRAINT  STRUKTURJOIN_G_P FOREIGN KEY
 ( GID )  REFERENCES ADIA.STRUKTUR ( GID ))
;

REM
REM End Foreign Keys
REM
 
CONNECT adia/passwd@IMNLehre

REM
REM Start DDL statements
REM
 
REM
REM End DDL statements
REM
 
REM
REM Start Stored Procedures
REM
 
REM 
REM Message : Created Procedure : TIME_1
REM 
 CREATE or REPLACE FUNCTION time_1(Dexpr IN DATE) RETURN CHAR IS convDate CHAR(8);
  BEGIN
    convDate := to_char(Dexpr,'hh24:mi:ss');
    RETURN( convDate );
  END; 
/

REM 
REM Message : Created Procedure : RIGHT
REM 
 CREATE OR REPLACE FUNCTION RIGHT(srcStr IN VARCHAR2, len IN INTEGER)
   RETURN VARCHAR2 IS dStr VARCHAR2(32767);
  BEGIN
    IF ( len >= LENGTH(srcStr) ) THEN
      RETURN( srcStr );
    END IF;
    dStr := SUBSTR(srcStr, LENGTH(srcStr) - len+1, len);
    RETURN ( dStr );
  END; 
/

REM 
REM Message : Created Procedure : CINT
REM 
 CREATE or REPLACE FUNCTION CINT(expn IN NUMBER) RETURN NUMBER IS
  BEGIN
     RETURN ( expn );
  END;
 
/

REM 
REM Message : Created Procedure : CCUR
REM 
 CREATE or REPLACE FUNCTION CCUR(expn IN NUMBER) RETURN NUMBER IS
   BEGIN
    RETURN ( round( expn, 2 ) );
  END; 
/

REM 
REM Message : Created Procedure : CDBL
REM 
 CREATE or REPLACE FUNCTION CDBL(expn IN NUMBER) RETURN NUMBER IS convNum NUMBER;
  BEGIN
      convNum := expn;
      RETURN ( convNum );
  END; 
/

REM 
REM Message : Created Procedure : INTDIV
REM 
 CREATE or REPLACE FUNCTION intdiv( a NUMBER, b NUMBER) RETURN NUMBER IS OUT NUMBER;
  BEGIN
     IF (a IS NULL) OR (b IS NULL) THEN
        RETURN NULL;
     ELSE
        out := trunc( round(a) / round(b) );
        RETURN out;
     END IF;
  END; 
/

REM 
REM Message : Created Procedure : NOTEQN
REM 
 CREATE or REPLACE FUNCTION noteqn( a NUMBER, b NUMBER ) RETURN NUMBER AS
  BEGIN
     IF a <> b THEN
        RETURN -1;
     ELSE
        RETURN 0;
     END IF;
  END; 
/

REM 
REM Message : Created Procedure : ORN
REM 
 CREATE or REPLACE FUNCTION orn( a NUMBER, b NUMBER) RETURN NUMBER AS
  BEGIN
     IF a <>0 OR b <>0 THEN
        RETURN -1;
     ELSE
        RETURN 0;
     END IF;
  END; 
/

REM 
REM Message : Created Procedure : LTN
REM 
 CREATE or REPLACE FUNCTION ltn( a NUMBER, b NUMBER) RETURN NUMBER AS
  BEGIN
     IF a < b THEN
        RETURN -1;
     ELSE
        RETURN 0;
     END IF;
  END; 
/

REM 
REM Message : Created Procedure : INTN
REM 
 CREATE or REPLACE FUNCTION INTN(expn IN NUMBER) RETURN NUMBER IS convNum NUMBER;
  BEGIN
      If expn >= 0 THEN
         convNum := TRUNC( expn );
      ELSE
         convNum := FLOOR( expn );
      END IF;
      RETURN( convNum );
  END; 
/

REM 
REM Message : Created Procedure : LEFT
REM 
 CREATE OR REPLACE FUNCTION LEFT(srcStr IN VARCHAR2, len IN INTEGER)
  RETURN VARCHAR2 IS dStr VARCHAR2(32767);
  BEGIN
      dStr := SUBSTR( srcStr, 1, len );
      RETURN ( dStr );
  END; 
/

REM 
REM Message : Created Procedure : DATEADD
REM 
 CREATE or REPLACE FUNCTION DATEADD(Intvl IN VARCHAR2,NIntvl IN NUMBER,Dexpr IN DATE)
  RETURN DATE IS convDate DATE;
  BEGIN
    IF LOWER(RTRIM(Intvl))='y' or LOWER(RTRIM(Intvl))='w' or LOWER(RTRIM(Intvl))='d' Then
       convDate := Dexpr+NIntvl;
       return(convDate);
    ELSIF LOWER(RTRIM(Intvl)) = 'm' then
       convDate := ADD_MONTHS(Dexpr,NIntvl);
       return(convDate);
    ELSIF LOWER(RTRIM(Intvl)) = 'q' then
       convDate := ADD_MONTHS(Dexpr,3*NIntvl);
       return(convDate);
    ELSIF LOWER(RTRIM(Intvl)) = 'ww' then
       convDate := Dexpr + 7*NIntvl;
       return(convDate);
    ELSIF LOWER(RTRIM(Intvl)) = 'h' then
       convDate := Dexpr + NIntvl/24;
       return(convDate);
    ELSIF LOWER(RTRIM(Intvl)) = 'n' then
       convDate := Dexpr + NIntvl/1440;
       return(convDate);
    ELSIF LOWER(RTRIM(Intvl)) = 's' then
       convDate := Dexpr + NIntvl/86400;
       return(convDate);
    ELSIF LOWER(RTRIM(Intvl)) = 'yyyy' then
       If TRUNC(NIntvl) = NIntvl Then
          convDate := ADD_MONTHS(Dexpr,NIntvl*12);
          return(convDate);
       Else
          convDate := Dexpr + NIntvl*365;
          return(convDate);
       END IF;
    END IF;
  END; 
/

REM 
REM Message : Created Procedure : EQN
REM 
 CREATE or REPLACE FUNCTION eqn( a NUMBER, b NUMBER ) RETURN NUMBER AS
  BEGIN
     IF a = b THEN
        RETURN -1;
     ELSE
        RETURN 0;
     END IF;
  END; 
/

REM 
REM Message : Created Procedure : NOTN
REM 
 CREATE or REPLACE FUNCTION notn( a NUMBER ) RETURN NUMBER AS
  BEGIN
     IF a = 0 THEN
        RETURN -1;
     ELSE
        RETURN 0;
     END IF;
  END; 
/

REM 
REM Message : Created Procedure : ANDN
REM 
 CREATE or REPLACE FUNCTION andn( a NUMBER, b NUMBER) RETURN NUMBER AS
  BEGIN
     IF a <>0 AND b <>0 THEN
        RETURN -1;
     ELSE
        RETURN 0;
     END IF;
  END; 
/

REM 
REM Message : Created Procedure : SPACE_
REM 
 CREATE OR REPLACE FUNCTION SPACE_(len IN NUMBER) RETURN VARCHAR2 IS dStr VARCHAR2(32767);
  BEGIN
    dStr := LPAD(' ', len , ' ');
    RETURN ( dStr );
  END; 
/

REM 
REM Message : Created Procedure : GTN
REM 
 CREATE or REPLACE FUNCTION gtn( a NUMBER, b NUMBER) RETURN NUMBER AS
  BEGIN
     IF a > b THEN
        RETURN -1;
     ELSE
        RETURN 0;
     END IF;
  END; 
/

REM 
REM Message : Created Procedure : GTEN
REM 
 CREATE or REPLACE FUNCTION gten( a NUMBER, b NUMBER) RETURN NUMBER AS
  BEGIN
     IF a >= b THEN
        RETURN -1;
     ELSE
        RETURN 0;
     END IF;
  END; 
/

REM 
REM Message : Created Procedure : LTEN
REM 
 CREATE or REPLACE FUNCTION lten( a NUMBER, b NUMBER) RETURN NUMBER AS
  BEGIN
     IF a <= b THEN
        RETURN -1;
     ELSE
        RETURN 0;
     END IF;
  END; 
/

REM 
REM Message : Created Procedure : ISN
REM 
 CREATE or REPLACE FUNCTION isn( a IN NUMBER, b IN VARCHAR2 ) RETURN NUMBER AS out NUMBER;
  BEGIN
     IF ( LOWER(b) = LOWER('NULL') ) THEN
        IF ( a IS NULL ) THEN
           RETURN -1;
        ELSE
           RETURN 0;
        END IF;
     ELSE
        IF ( a IS NOT NULL ) THEN
           RETURN -1;
        ELSE
           RETURN 0;
        END IF;
     END IF;
  END; 
/

REM 
REM Message : Created Procedure : MID
REM 
 CREATE OR REPLACE FUNCTION MID(srcStr IN VARCHAR2, strt IN INTEGER, len IN NUMBER DEFAULT 32767)
  RETURN VARCHAR2 IS dStr VARCHAR2(32767);
  BEGIN
    If ( strt > Length(srcStr) ) Then
      RETURN( NULL );
    END IF;
    dStr := SUBSTR( srcStr, strt, len );
    RETURN ( dStr );
  END; 
/

REM 
REM Message : Created Procedure : CLNG
REM 
 CREATE or REPLACE FUNCTION CLNG(expn IN NUMBER) RETURN NUMBER IS
  BEGIN
     RETURN ( expn );
  END; 
/

REM 
REM Message : Created Procedure : TRIM
REM 
 CREATE or REPLACE FUNCTION trim ( Dexpr IN VARCHAR2 ) RETURN VARCHAR2 IS
  BEGIN
     RETURN LTRIM( RTRIM ( Dexpr ) );
  END; 
/

REM 
REM Message : Created Procedure : RND
REM 
 CREATE or REPLACE FUNCTION rnd
   RETURN NUMBER AS
     m  CONSTANT NUMBER:=100000000;
     m1 CONSTANT NUMBER:=10000;
     b  CONSTANT NUMBER:=31415821;
     a           NUMBER;
     the_date    DATE;
     days        NUMBER;
     secs        NUMBER;
     iMul        NUMBER;
     p1          NUMBER;
     p0          NUMBER;
     q1          NUMBER;
     q0          NUMBER;
  BEGIN
     the_date := SYSDATE;
     days     := TO_NUMBER( to_char( the_date, 'J'    ) );
     secs     := TO_NUMBER( to_char( the_date, 'SSSSS') );
     a        := days * 24 * 3600 + secs;
     p1       := TRUNC( a / m1 );
     p0       := MOD  ( a,  m1 );
     q1       := TRUNC( b / m1 );
     q0       := MOD  ( b,  m1 );
     iMul     :=( MOD( ( MOD( p0*q1+p1*q0,m1 ) *m1+p0*q0 ), m ) );
     a        :=MOD( iMul+1, m );
     RETURN( a/m );
  END; 
/

REM 
REM Message : Created Procedure : TIME_2
REM 
 CREATE or REPLACE FUNCTION time_2 RETURN CHAR IS convDate CHAR(8);
  BEGIN
     convDate := to_char( SYSDATE, 'hh24:mi:ss');
     RETURN ( convDate );
  END; 
/

REM
REM End Stored Procedures
REM

