------------------------------------------------------------------
-- These are the SQL statements to drop any objects from the
-- Oracle Model that have been created in an Oracle database.
------------------------------------------------------------------
 
REM
REM Start Stored Procedures
REM

CONNECT adia/passwd@IMNLehre
 
REM 
REM Created Procedure : ADIA.TIME_1
REM 
DROP FUNCTION ADIA.TIME_1;

REM 
REM Created Procedure : ADIA.RIGHT
REM 
DROP FUNCTION ADIA.RIGHT;

REM 
REM Created Procedure : ADIA.CINT
REM 
DROP FUNCTION ADIA.CINT;

REM 
REM Created Procedure : ADIA.CCUR
REM 
DROP FUNCTION ADIA.CCUR;

REM 
REM Created Procedure : ADIA.CDBL
REM 
DROP FUNCTION ADIA.CDBL;

REM 
REM Created Procedure : ADIA.INTDIV
REM 
DROP FUNCTION ADIA.INTDIV;

REM 
REM Created Procedure : ADIA.NOTEQN
REM 
DROP FUNCTION ADIA.NOTEQN;

REM 
REM Created Procedure : ADIA.ORN
REM 
DROP FUNCTION ADIA.ORN;

REM 
REM Created Procedure : ADIA.LTN
REM 
DROP FUNCTION ADIA.LTN;

REM 
REM Created Procedure : ADIA.INTN
REM 
DROP FUNCTION ADIA.INTN;

REM 
REM Created Procedure : ADIA.LEFT
REM 
DROP FUNCTION ADIA.LEFT;

REM 
REM Created Procedure : ADIA.DATEADD
REM 
DROP FUNCTION ADIA.DATEADD;

REM 
REM Created Procedure : ADIA.EQN
REM 
DROP FUNCTION ADIA.EQN;

REM 
REM Created Procedure : ADIA.NOTN
REM 
DROP FUNCTION ADIA.NOTN;

REM 
REM Created Procedure : ADIA.ANDN
REM 
DROP FUNCTION ADIA.ANDN;

REM 
REM Created Procedure : ADIA.SPACE_
REM 
DROP FUNCTION ADIA.SPACE_;

REM 
REM Created Procedure : ADIA.GTN
REM 
DROP FUNCTION ADIA.GTN;

REM 
REM Created Procedure : ADIA.GTEN
REM 
DROP FUNCTION ADIA.GTEN;

REM 
REM Created Procedure : ADIA.LTEN
REM 
DROP FUNCTION ADIA.LTEN;

REM 
REM Created Procedure : ADIA.ISN
REM 
DROP FUNCTION ADIA.ISN;

REM 
REM Created Procedure : ADIA.MID
REM 
DROP FUNCTION ADIA.MID;

REM 
REM Created Procedure : ADIA.CLNG
REM 
DROP FUNCTION ADIA.CLNG;

REM 
REM Created Procedure : ADIA.TRIM
REM 
DROP FUNCTION ADIA.TRIM;

REM 
REM Created Procedure : ADIA.RND
REM 
DROP FUNCTION ADIA.RND;

REM 
REM Created Procedure : ADIA.TIME_2
REM 
DROP FUNCTION ADIA.TIME_2;

REM
REM End Stored Procedures
REM

REM
REM Start Foreign Keys
REM
 
REM 
REM Created Foreign Key :GRUPPEN_TYPSTRUKTUR
REM 
ALTER TABLE ADIA.STRUKTUR DROP CONSTRAINT GRUPPEN_TYPSTRUKTUR CASCADE;

REM 
REM Created Foreign Key :HERSTELLERADRESSE
REM 
ALTER TABLE ADIA.ADRESSE DROP CONSTRAINT HERSTELLERADRESSE CASCADE;

REM 
REM Created Foreign Key :HERSTELLERPRODUKT
REM 
ALTER TABLE ADIA.PRODUKT DROP CONSTRAINT HERSTELLERPRODUKT CASCADE;

REM 
REM Created Foreign Key :KATALOGSTRUKTUR
REM 
ALTER TABLE ADIA.STRUKTUR DROP CONSTRAINT KATALOGSTRUKTUR CASCADE;

REM 
REM Created Foreign Key :PRODUKTBILDER
REM 
ALTER TABLE ADIA.BILDER DROP CONSTRAINT PRODUKTBILDER CASCADE;

REM 
REM Created Foreign Key :ProduktJOIN_G_P
REM 
ALTER TABLE ADIA.JOIN_G_P DROP CONSTRAINT ProduktJOIN_G_P CASCADE;

REM 
REM Created Foreign Key :STRUKTURJOIN_G_P
REM 
ALTER TABLE ADIA.JOIN_G_P DROP CONSTRAINT STRUKTURJOIN_G_P CASCADE;

REM
REM End Foreign Keys
REM

REM
REM Start Primary Keys
REM
 
REM 
REM Created Primary Key :PK_ADRESSE
REM 
ALTER TABLE ADIA.ADRESSE DROP PRIMARY KEY CASCADE;

REM 
REM Created Primary Key :PK_BILDER
REM 
ALTER TABLE ADIA.BILDER DROP PRIMARY KEY CASCADE;

REM 
REM Created Primary Key :PK_GRUPPEN_TYP
REM 
ALTER TABLE ADIA.GRUPPEN_TYP DROP PRIMARY KEY CASCADE;

REM 
REM Created Primary Key :PK_HERSTELLER
REM 
ALTER TABLE ADIA.HERSTELLER DROP PRIMARY KEY CASCADE;

REM 
REM Created Primary Key :PK_JOIN_G_P
REM 
ALTER TABLE ADIA.JOIN_G_P DROP PRIMARY KEY CASCADE;

REM 
REM Created Primary Key :PK_KATALOG
REM 
ALTER TABLE ADIA.KATALOG DROP PRIMARY KEY CASCADE;

REM 
REM Created Primary Key :PK_PRODUKT
REM 
ALTER TABLE ADIA.PRODUKT DROP PRIMARY KEY CASCADE;

REM 
REM Created Primary Key :PK_STRUKTUR
REM 
ALTER TABLE ADIA.STRUKTUR DROP PRIMARY KEY CASCADE;

REM
REM End Primary Keys
REM

REM
REM Start Indexes
REM
 
REM 
REM Created Index :UQ_ADRESSE
REM 
DROP INDEX UQ_ADRESSE;

REM 
REM Created Index :UQ_ADRESSE_1
REM 
DROP INDEX UQ_ADRESSE_1;

REM 
REM Created Index :AID
REM 
DROP INDEX AID;

REM 
REM Created Index :BILDID
REM 
DROP INDEX BILDID;

REM 
REM Created Index :HID
REM 
DROP INDEX HID;

REM 
REM Created Index :AID_1
REM 
DROP INDEX AID_1;

REM 
REM Created Index :GID
REM 
DROP INDEX GID;

REM 
REM Created Index :EXT_PRODUCT_ID
REM 
DROP INDEX EXT_PRODUCT_ID;

REM 
REM Created Index :MANUFACTCODE
REM 
DROP INDEX MANUFACTCODE;

REM 
REM Created Index :CATALOG_ID
REM 
DROP INDEX CATALOG_ID;

REM 
REM Created Index :CID
REM 
DROP INDEX CID;

REM 
REM Created Index :PARENT_ID
REM 
DROP INDEX PARENT_ID;

REM
REM End Indexes
REM
 
REM
REM Start Tables
REM
 
REM 
REM Created Table :ADIA.ADRESSE
REM 
DROP TABLE ADIA.ADRESSE;

REM 
REM Processed defaults for table :ADIA.ADRESSE
REM 
;

REM 
REM Created Table :ADIA.BILDER
REM 
DROP TABLE ADIA.BILDER;

REM 
REM Processed defaults for table :ADIA.BILDER
REM 
;

REM 
REM Created Table :ADIA.GRUPPEN_TYP
REM 
DROP TABLE ADIA.GRUPPEN_TYP;

REM 
REM Processed defaults for table :ADIA.GRUPPEN_TYP
REM 
;

REM 
REM Created Table :ADIA.HERSTELLER
REM 
DROP TABLE ADIA.HERSTELLER;

REM 
REM Processed defaults for table :ADIA.HERSTELLER
REM 
;

REM 
REM Created Table :ADIA.JOIN_G_P
REM 
DROP TABLE ADIA.JOIN_G_P;

REM 
REM Processed defaults for table :ADIA.JOIN_G_P
REM 
;

REM 
REM Created Table :ADIA.KATALOG
REM 
DROP TABLE ADIA.KATALOG;

REM 
REM Processed defaults for table :ADIA.KATALOG
REM 
;

REM 
REM Created Table :ADIA.PRODUKT
REM 
DROP TABLE ADIA.PRODUKT;

REM 
REM Processed defaults for table :ADIA.PRODUKT
REM 
;

REM 
REM Created Table :ADIA.STRUKTUR
REM 
DROP TABLE ADIA.STRUKTUR;

REM 
REM Processed defaults for table :ADIA.STRUKTUR
REM 
;

REM
REM End Tables
REM